C$PROG WHERE
      SUBROUTINE WHERE (Q,INQ,DEXIT,DTFP,XI2PP,TL,TR,RDIST,IJ,NQ)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/AAA/ Z(4), NZ(30), CONST(50), ZZ(25)
      DIMENSION Q(10), DEXIT(10), DTFP(10), XI2PP(10), RDIST(10), IJ(10)
     1, XX(10), YY(10), TRIG(2), DN(2), DIS(2), DTFPP(2), DELKIN(2)
      EQUIVALENCE (CONST(2),ACONST),(CONST(3),AK0),(CONST(4),ALP),(CO
     1NST(5),AM),(CONST(6),AN),(CONST(9),BETA),(CONST(10),BL),(CONST
     2(17),DB),(CONST(21),DL0),(CONST(31),TLC),(CONST(32),TRC),(CONS
     3T(8),BAR2),(CONST(27),SI)
C   
      EQUIVALENCE (ILRD  ,ZZ(2)),
     &            (OMEGA ,ZZ(15))
C   
C   
C     ******************************************************************
C     SUBROUTINE WHERE CONTAINS THE GEOMETRY OF THE DETECTOR BOX.
C     IT CONVERTS THE OUTPUT OF OPTIC INTO PHYSICAL PARAMETERS NEEDED
C     TO PLACE THE DETECTOR BAR IN THE FOCAL PLANE.  IT GIVES THE LEFT
C     AND RIGHT DIAL READINGS (TL AND TR) AND DISTANCE ALONG THE FOCAL
C     PLANE (RDIST) WHERE THE REACTION COMES TO FOCUS .
C     ******************************************************************
C   
      IF (ILRD.NE.0) GO TO 3
      DO 1 J=1,NQ
      XX(J)=DEXIT(J)+DTFP(J)*DSIN(XI2PP(J))-SI
      YY(J)=DTFP(J)*DCOS(XI2PP(J))-BAR2
1     continue      
      OMEGA=DATAN((YY(1)-YY(INQ))/(XX(1)-XX(INQ)))
      FAC3=AM-BL*DCOS(OMEGA)+BL*DSIN(OMEGA)/TAN(BETA)
      DLP=(YY(1)+(FAC3-XX(1))*DTAN(OMEGA))/(1.-DTAN(OMEGA)/TAN(BETA))
      DLH=(DLP/TAN(BETA))+FAC3-DB*DSIN(OMEGA)
      X=DLH+DB*DSIN(OMEGA)+ALP*DCOS(OMEGA)
      Y=DLP+ALP*DSIN(OMEGA)
      TL=(DL0-DLP-DB*DCOS(OMEGA))/AN
      TR=(AK0-Y-X*ACONST)/AN
      TL=TL+TLC
      TR=TR+TRC
      DO 2 I=1,NQ
      RDIST(I)=ALP-((YY(I)-DLP)/DSIN(OMEGA))
2     CONTINUE
      RETURN
3     CONTINUE
      DO 4 I=1,2
      TRIG(I)=DSIN(OMEGA)-DCOS(OMEGA)/DTAN(XI2PP(I))
      DLHP=DLP/TAN(BETA)+FAC3
      DN(I)=(DLHP-DEXIT(I)+34.6)/DTAN(XI2PP(I))-23.124-DLP
      DIS(I)=DN(I)/TRIG(I)
      RDIST(I)=ALP-DIS(I)
      DTFPP(I)=((ALP-RDIST(I))*DSIN(OMEGA)+23.124+DLP)/DCOS(XI2PP(I))
      DELKIN(I)=DTFPP(I)-DTFP(I)
4     continue
      RETURN
      END
